import { ReactElement } from "react";
export declare type UseQueryResult<T> = {
    originalArgs?: unknown;
    data?: T;
    currentData?: T;
    error?: unknown;
    requestId?: string;
    endpointName?: string;
    startedTimeStamp?: number;
    fulfilledTimeStamp?: number;
    isUninitialized: boolean;
    isLoading: boolean;
    isFetching: boolean;
    isSuccess: boolean;
    isError: boolean;
    refetch: () => void;
};
export declare type LoaderTransformFunction<QRU extends readonly UseQueryResult<unknown>[], R extends unknown> = (queries: QRU) => R;
export declare type OptionalGenericArg<T> = T extends never ? [] : [T];
export declare type CreateLoaderArgs<QRU extends readonly UseQueryResult<unknown>[], R extends unknown, A = never> = {
    queries: (...args: OptionalGenericArg<A>) => QRU;
    transform?: LoaderTransformFunction<QRU, R>;
};
export declare type UseLoader<A, R> = (...args: OptionalGenericArg<A>) => UseQueryResult<R>;
export declare type CreateLoaderType = <QRU extends readonly UseQueryResult<unknown>[], R extends unknown = QRU, A = never>(createLoaderArgs: CreateLoaderArgs<QRU, R, A>) => UseLoader<A, R>;
export declare type ComponentWithLoaderData<P extends Record<string, any>, R extends unknown> = (props: P, loaderData: R) => ReactElement;
declare type InferQueryResult<T> = T extends UseQueryResult<infer X> ? X : never;
export declare type InferLoaderData<T> = T extends UseLoader<any, any> ? InferQueryResult<ReturnType<T>> : never;
export {};
