import { ReactElement } from "react";
import * as Types from "./types";
export declare type WithLoaderArgs<P extends unknown, R extends unknown, A = never> = {
    useLoader: Types.UseLoader<A, R>;
    useLoaderArg?: (props: P) => A;
    onLoading?: (props: P) => ReactElement;
};
export declare type Component<P extends Record<string, unknown>> = (props: P) => ReactElement;
export declare const withLoader: <P extends Record<string, unknown>, R extends unknown, A = never>(Component: Types.ComponentWithLoaderData<P, R>, args: WithLoaderArgs<P, R, A>) => Component<P>;
